 

import greenfoot.*;
import java.awt.Color;

public class Player extends FreeObject
{
	private float V = 150;
	private float Ay = 1000;
	private float theta = 60;
	
	public Player(){
		Vx = 0;
		Vy = 0;
		
		GreenfootImage ball =  PixelFactory.Ball(7);
		PixelFactory.replace(ball, PixelFactory.defaltColors3, ColorPicker.getColors3(0.55f));
		
		GreenfootImage eye = new GreenfootImage("Eye.png");
		ball.drawImage(eye, (int)Math.round(7 * Math.sin(Math.toRadians(theta))), 5);
		
		//PixelFactory.scale(ball, 3);
		ball = PixelFactory.stroke(ball, Color.BLACK, 2.9f, true);
		PixelFactory.scale(ball, 3);
		setImage(ball);
	}
	
	public void act(float dt){
		if(Greenfoot.isKeyDown("left") && !Greenfoot.isKeyDown("right") && bottomIn){
			Vx = -V;
		}
		else if(Greenfoot.isKeyDown("right") && !Greenfoot.isKeyDown("left") && bottomIn){
			Vx = V;
		}
		else if(bottomIn)
		Vx = 0;
		x += Vx *dt;
		Vy += Ay * dt;
		y += Vy * dt;
		isAway();
		intersect();
		if(bottomIn || topIn)
			Vy = 0;
		if(leftIn || rightIn)
			Vx = 0;
		if((Greenfoot.isKeyDown("space") || Greenfoot.isKeyDown("up")) && bottomIn){
			Vy = -750;
		}
		
		getWorld().moveTo(x, y);
		locate();
	}
	
	private void isAway(){
		if(y > getWorld().worldHeight + 300)
			y = oldY;
		x = Math.max(0, x);
		x = Math.min(getWorld().worldWidth, x);
			
	}
	
	
	
	private void draw(){
		getImage().setColor(Color.WHITE);
		getImage().fill();
		getImage().setColor(Color.BLACK);
		getImage().drawString("" + getTop(), 10, 10);
		getImage().drawString("" + y, 10, 20);
		getImage().drawString("" + getBottom(), 10, 30);
		getImage().drawString("" + getImage().getWidth(), 10, 40);
		//getImage().drawString("" + getWorld().getTimeSpace(), 10, 40);
	}
}
