package greenfoot;

import java.lang.Class;
import java.util.ArrayList;
import java.util.List;

public class ClassImageManager
{
    static List<Class> classes = new ArrayList<Class>();
	static List<GreenfootImage> classImages = new ArrayList<GreenfootImage>();
	
	static GreenfootImage defaultImage = new GreenfootImage("default.png");
	
	public static GreenfootImage getClassImage(Class cls){
		if(cls == Actor.class)
			return defaultImage;
		
		Class currentClass = null;
		GreenfootImage currentClassImage = null;
		for(int i = 0; i < classes.size(); i++){
			Class class_i = classes.get(i);
			if(class_i.isAssignableFrom(cls) 
				&& (currentClass == null || currentClass.isAssignableFrom(class_i))){
				currentClass = class_i;
				currentClassImage = classImages.get(i);
			}
		}
		if(currentClassImage == null)
			return defaultImage;
		
		return currentClassImage;
	}
	
	public static void setClassImage(Class cls, GreenfootImage classImg){
		if(cls == Actor.class)
			return;
		
		Class currentClass = null;
		for(int i = 0; i < classes.size(); i++){
			Class class_i = classes.get(i);
			if(class_i.isAssignableFrom(cls) 
			   && (currentClass == null || currentClass.isAssignableFrom(class_i))){
				currentClass = class_i;
				classImages.set(i, classImg);
			}
		}
		
		if(currentClass == null){
			classes.add(cls);
			classImages.add(classImg);
		}
	}
}
