package runner;

import greenfoot.*;

public class ColorPicker
{
	public static Color Brighter(Color color){
		float[] hsb = new float[3];
		Color.RGBtoHSB(color.getRed(), color.getGreen(), color.getBlue(), hsb);
		hsb[2] += 0.15;
		hsb[2] = Math.min(1, hsb[2]);
		return new Color(Color.HSBtoRGB(hsb[0], hsb[1], hsb[2]));
	}
	
	public static Color Darker(Color color){
		float[] hsb = new float[3];
		Color.RGBtoHSB(color.getRed(), color.getGreen(), color.getBlue(), hsb);
		hsb[2] -= 0.15;
		hsb[2] = Math.max(0, hsb[2]);
		return new Color(Color.HSBtoRGB(hsb[0], hsb[1], hsb[2]));
	}

	public static Color fix(Color color1, Color color2, float rate){
	    int r = Math.round(color1.getRed() * rate + color2.getRed() * (1 - rate));
	    r = Math.min(r, 255);
	    r = Math.max(r, 0);
	    int g = Math.round(color1.getGreen() * rate + color2.getGreen() * (1 - rate));
	    g = Math.min(g, 255);
	    g = Math.max(g, 0);
	    int b = Math.round(color1.getBlue() * rate + color2.getBlue() * (1 - rate));
	    b = Math.min(b, 255);
	    b = Math.max(b, 0);
	    return new Color(r, g, b);
	}
	
	public static Color[] getColors3(Color color){
		return new Color[]{Brighter(color), color, Darker(color)};
	}
	
	public static Color[] getColors5(Color color){
		return new Color[]{Brighter(Brighter(color)), Brighter(color), color, Darker(color), Darker(Darker(color))};
	}
	
	public static Color[] getColors3(float h){
		Color color = new Color(Color.HSBtoRGB(h, 1f, 0.6f));
		return getColors3(color);
	}
	
	public static Color[] getColors5(float h){
		Color color = new Color(Color.HSBtoRGB(h, 1f, 0.6f));
		return getColors5(color);
	}
}
