package runner;

import greenfoot.*;
import java.util.List;

public class FreeObject extends ScrollActor
{
	protected float oldX;
	protected float oldY;
	
	protected boolean topIn;
	protected boolean bottomIn;
	protected boolean leftIn;
	protected boolean rightIn;
	
	public float Vx;
	public float Vy;
	
	public boolean grounded = false;
	
	@Override
	public void act(){
		super.act();
		oldX = x;
		oldY = y;
	}

	public boolean noRotationTopIntersects(GroundedObject ground){
		float dx = Math.abs(x - ground.x);
		float dy = Math.abs(y - ground.y);
		float xLimit = (getImage().getWidth() + ground.getImage().getWidth()) / 2f;
		float yLimit = (getImage().getHeight() + ground.getImage().getHeight()) / 2f;
		return (y < ground.y && dx < xLimit && dy <= yLimit); 
	}
	
	public boolean noRotationBottomIntersects(GroundedObject ground){
		float dx = Math.abs(x - ground.x);
		float dy = Math.abs(y - ground.y);
		float xLimit = (getImage().getWidth() + ground.getImage().getWidth()) / 2f;
		float yLimit = (getImage().getHeight() + ground.getImage().getHeight()) / 2f;
		return (y > ground.y && dx < xLimit && dy <= yLimit); 
	}
	
	public boolean noRotationLeftIntersects(GroundedObject ground){
		float dx = Math.abs(x - ground.x);
		float dy = Math.abs(y - ground.y);
		float xLimit = (getImage().getWidth() + ground.getImage().getWidth()) / 2f;
		float yLimit = (getImage().getHeight() + ground.getImage().getHeight()) / 2f;
		return (x < ground.x && dx <= xLimit && dy < yLimit); 
	}
	
	public boolean noRotationRightIntersects(GroundedObject ground){
		float dx = Math.abs(x - ground.x);
		float dy = Math.abs(y - ground.y);
		float xLimit = (getImage().getWidth() + ground.getImage().getWidth()) / 2f;
		float yLimit = (getImage().getHeight() + ground.getImage().getHeight()) / 2f;
		return (x > ground.x && dx <= xLimit && dy < yLimit); 
	}
	
	protected void intersect(){
		topIn = false;
		bottomIn = false;
		leftIn = false;
		rightIn = false;
		
		List groundList = getObjectsInRange(500, GroundedObject.class);
		if(groundList != null && !groundList.isEmpty())
		for(int i = 0; i < groundList.size(); i++){
			GroundedObject ground = (GroundedObject)groundList.get(i);
			
			if(noRotationTopIntersects(ground))
			if(topEnter(ground)){
				y = ground.getTop() - getImage().getHeight() / 2f;
				bottomIn = true;
			}
			
			if(noRotationBottomIntersects(ground))
			if(bottomEnter(ground)){
				y = ground.getBottom() + getImage().getHeight() / 2f;
				topIn = true;
			}
			
			if(noRotationLeftIntersects(ground))
			if(leftEnter(ground)){
				x = ground.getLeft() - getImage().getWidth() / 2f;
				rightIn = true;
			}
			
			if(noRotationRightIntersects(ground))
			if(rightEnter(ground)){
				x = ground.getRight() + getImage().getWidth() / 2f;
				leftIn = true;
			}
		}
	}
	
	protected boolean topEnter(ActorX actor){
		return getBottom(oldY) <= actor.getTop() && getBottom() >= actor.getTop();
	}
	
	protected boolean bottomEnter(ActorX actor){
		return getTop(oldY) >= actor.getBottom() && getTop() <= actor.getBottom();
	}
	
	protected boolean leftEnter(ActorX actor){
		return getRight(oldX) <= actor.getLeft() && getRight() >= actor.getLeft();
	}
	
	protected boolean rightEnter(ActorX actor){
		return getLeft(oldX) >= actor.getRight() && getLeft() <= actor.getRight();
	}
	
	//boolean
	
	public boolean isGrounded(){
		List groundList = getObjectsInRange(50, GroundedObject.class);
		if(groundList != null && !groundList.isEmpty())
		for(int i = 0; i < groundList.size(); i++){
			GroundedObject ground = (GroundedObject)groundList.get(i);
			//if(x - getImage().getHeight() / 2f )
		}
		return grounded;
	}
}
