package runner;

import greenfoot.*;

public class Space extends GridScrollWorld
{
	Player player = new Player();
	
	public Space(){
		super(800, 480, 1);
		
		worldWidth = 2400;
		worldHeight = 479;
		gridSize = 60;
		
		//getBackground().setColor(Color.CYAN);
        //Color color1 = new Color(Color.HSBtoRGB(0.587f, 0.2f, 1.0f));
        //Color color2 = new Color(Color.HSBtoRGB(0.587f, 0.85f, 0.65f));
        int depth = 10;
        Color color1 = new Color(Color.HSBtoRGB(0.1307f, 0.2f, 1.0f));
        Color color2 = new Color(Color.HSBtoRGB(0.1307f, 1f, 1f));
        //Color color3 = new Color(Color.HSBtoRGB(0.806f, 1.0f, 1.0f));
        for(int i = 0; i < 480 / 3; i++){
            float rate = (i + 0.5f);
            rate += Greenfoot.getRandomNumber(depth * 2 + 1) - depth;
            rate /= 480 / 3;
            Color color = ColorPicker.fix(color1, color2, rate);
            
            getBackground().setColor(color);
            getBackground().fillRect(0, i * 3, 800, 3);

        }
		
		setActOrder(Player.class);
		setPaintOrder(FreeObject.class, GroundedObject.class, Cloud.class);
		
		addObject(player, 160f, 0f);
		
		addObject(new Cloud(), 500, 100);
		
		//
		addObject(new Brick(), 2, 4);
		addObject(new Brick(), 2, 2);
		addObject(new Brick(), 3, 7);
		addObject(new Brick(), 4, 1);
		 
		for(int i = 0; i < worldWidth / gridSize; i++)
		addObject(new Brick(), i, (int)(worldHeight / gridSize));
		
		Greenfoot.setInputMod(Greenfoot.keyBoardMod);
		Greenfoot.start();
	}
}
