package runner;

import greenfoot.*;

public class WorldX extends World
{
	private long oldTime;
	private long newTime;
	private float timeSpace;
	
	public WorldX(int width, int height, int cellSize){
		super(width, height, cellSize);
		
		oldTime = System.currentTimeMillis();
		newTime = oldTime;
		timeSpace = 0;
	}
	
	@Override
	public void addObject(Actor actor, int x, int y){
		super.addObject(actor, x, y);
		if(ActorX.class.isAssignableFrom(actor.getClass())){
			((ActorX)actor).x = x;
			((ActorX)actor).y = y;
		}
	}
	
	public void addObject(Actor actor, float x, float y){
		addObject(actor, (int)x, (int)y);
	}
	
	public void addObject(ActorX actor){
		addObject(actor, actor.x, actor.y);
	}
	
	@Override
	public void act(){
		newTime = System.currentTimeMillis();
		timeSpace = (newTime - oldTime) / 1000f;
		oldTime = newTime;
		
		act(timeSpace);
	}
	
	public void act(float dt){
	}
	
	public float getTimeSpace(){
		return timeSpace;
	}
	
	@Override
	public void started(){
		newTime = System.currentTimeMillis();
		oldTime = newTime;
	}
}
